if(isfile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	RTB_registerPref("Toggle","Score Saver","ScoreSaver::Toggle","bool","Script_ScoreSaver",1,0,1);
	RTB_registerPref("Can Reset Scores","Score Saver","ScoreSaver::CanReset","list Host 1 SuperAdmin 2 Admin 3",2,0,1);
}
else
{
	$ScoreSaver::Toggle = 1;
	$ScoreSaver::CanReset = 2;
}

package ScoreSaver
{
	function SaveScore(%client)
	{
		%score = %client.score;
		%file = new FileObject();
		%file.openforwrite("Config/Server/SavedScores/"@%client.bl_id@".txt");
		%file.writeline(%score);
		%file.close();
		%file.delete();
	}

	function LoadScore(%client)
	{
		%file = new FileObject();
		%file.openforread("Config/Server/SavedScores/"@%client.bl_id@".txt");
		%score = %file.readline();
		%client.setscore(%score);
		%file.close();
		%file.delete();
	}

	function MinigameSO::addMember(%mini,%client)
	{
		Parent::addMember(%mini,%client);
		if($ScoreSaver::Toggle)
		{
			LoadScore(%client);
		}
	}
	
	function MinigameSO::removeMember(%mini,%client)
	{
		if($ScoreSaver::Toggle)
		{
			SaveScore(%client);
		}
		Parent::removeMember(%mini,%client);
	}

	function serverCmdEndMiniGame(%client)
	{
		if($ScoreSaver::Toggle)
		{
			for(%i=0;%i<clientgroup.getCount();%i++)
			{
				%cl = clientGroup.getObject(%i);
				if(isObject(%cl.minigame))
					SaveScore(%cl);
			}
		}
		Parent::serverCmdEndMiniGame(%client);
	}
	
	function MinigameSO::Reset(%mini,%client)
	{
		if($ScoreSaver::Toggle)
		{
			for(%i=0;%i<clientgroup.getCount();%i++)
			{
				%cl = clientgroup.getObject(%i);
				if(isObject(%cl.minigame))
					SaveScore(%cl);
			}
		}
		Parent::Reset(%mini,%client);
		if($ScoreSaver::Toggle)
		{
			for(%a=0;%a<clientgroup.getCount();%a++)
			{
				%clt = clientgroup.getObject(%a);
				LoadScore(%clt);
			}
		}
	}

	function serverCmdresetallscores(%client)
	{
		%host = %client.bl_id == getnumkeyid();
		switch($ScoreSaver::CanReset)
		{
			case 1:
				if(!%host)
				{
					MessageClient(%client,'',"\c6You are not allowed to reset scores");
					return;
				}
			case 2:
				if(!%client.isSuperAdmin)
				{
					MessageClient(%client,'',"\c6You are not allowed to reset scores");
					return;
				}
			case 3:
				if(!%client.isAdmin)
				{
					MessageClient(%client,'',"\c6You are not allowed to reset scores");
					return;
				}
		}
		for(%i = findFirstFile("Config/Server/SavedScores/*.txt");%i!$="";%i=findNextFile("Config/Server/SavedScores/*.txt"))
			filedelete(%i);
		for(%a=0;%a<clientgroup.getCount();%a++)
		{
			%cl = clientgroup.getObject(%a);
			%cl.setscore(0);
		}
		MessageAll('',"All scores reset");
	}
};
activatepackage(ScoreSaver);

if(isfile("Add-Ons/Gamemode_Slayer/server.cs"))
	exec("./slayersupport.cs");